//kHelperと同時に使うと面倒な気がするので切り換えて利用して下さい。
var myHelper = new (function (thisdir) {
  var win = sirius.ActiveXObject('sirius_core.siriusWindow');
  win.titleSafix = 'myHelper';
  this.currentBgColor = '#99ffff';
  this.nextKeyGuide = true;
  this.vkeyView = true;
  this.width = 10;
  this.nameStr = "息吹";

  var keys = {
    'jp' : [
      [ 49,  50,  51,  52,  53,  54,  55,  56,  57,  48, 189, 222, 220 ],
      [ 81,  87,  69,  82,  84,  89,  85,  73,  79,  80, 192, 219, 255 ],
      [ 65,  83,  68,  70,  71,  72,  74,  75,  76, 187, 186, 221, 255 ],
      [ 90,  88,  67,  86,  66,  78,  77, 188, 190, 191, 226, 255, 255 ]
      ],

    'us' : [
      [ 49,  50,  51,  52,  53,  54,  55,  56,  57,  48, 189, 187, 255 ],
      [ 81,  87,  69,  82,  84,  89,  85,  73,  79,  80, 219, 221, 255 ],
      [ 65,  83,  68,  70,  71,  72,  74,  75,  76, 186, 222, 220, 255 ],
      [ 90,  88,  67,  86,  66,  78,  77, 188, 190, 191, 193, 255, 255 ]
      ]
    };

  //  var keyboardMode = siriusKanchokuController.keyboardMode;
  //  if (!keyboardMode) keyboardMode = 'jp';
  var keyboardMode = 'jp';

  this.nextGuide = function (vk, kmode) {
    if (!myHelper.nextKeyGuide) return "";
    var imef = sirius.imeStatus();
    var width = myHelper.width;
    var str = '<div id="next-map"><table><tbody>';
    for (var i = 0; i < 4; i++) {
      str += '<tr>';
      for (var j = 0; j < width; j++) {
        var code = keys[keyboardMode][i][j];
        if (code == vk) str += '<td style="background:' + myHelper.currentBgColor + '">';
        else str += '<td>';
        str += imef ? getNext(code) : '&nbsp;';
        str += '</tr>';
        //
        if (!i && j == 4) {
          str += '<td rowspan="4">'
            str += imef ? getNext(32) : '&nbsp;';
          str += '</td>';
        }
      }
    }
    str += '</tbody></table></div>';
    return str;
  }

  this.vkeyView = function (vk) {
    if (!myHelper.vkeyView) return "";
    var vk16 = '0x' + ('0' + vk.toString(16)).substr(vk < 16 ? 0 : 1);
    var vkStr = sirius.vkeyToString(vk, keyboardMode);
    str = '<div id="vkey-view">';
    str += '<span id="vkey-str">VK:' + vkStr + '</span>';
    str += '<span id="innerkey">key:' + myinput.key() + '</span>';
    str += '<span id="vkey">/' + vk + '</span>';
    str += '<span id="vkey16">[' + vk16 + ']</span>';
    str += '</div>';
    return str;
  }

  function getNext (code) {
    var s = myinput.getInnerStr(code);
    if (!s) return "&nbsp;"; // "^o^";
    if (typeof s == "string") return myinput.filter(s);
    //
    var r = s[2]&3 ? "90" : "00";
    var g = s[2]&12 ? "90" : "00";
    var b = s[2] ? "00" : "ff";
    if (s[1]) s = s[1];
    else s = s[0];
    return "<font color=#"+r+g+b+">"+myinput.filter(s)+"</font>";
  }

  function create() {
    var winHeight = (myHelper.nextKeyGuide ? (1 + 20 * 4) : 0) + (myHelper.vkeyView ? 18 : 0);
    var winWidth = 1 + 2 * 20 * (myHelper.width + 1);
    win.open(thisdir + 'window.html', 32, 32, winWidth, winHeight, 'SW_HIDE',
             'WS_OVERLAPPED|WS_CAPTION|WS_SYSMENU' , 'WS_EX_TOPMOST|WS_EX_TOOLWINDOW', false, 'root', window);
  }
  function _show() {
    if (!win.isWindow) create();
    //    win.title = siriusKanchokuController.name;
    var name = myHelper.nameStr;
    win.title = name;
    win.show('SW_SHOWNA');
  }
  function _hide() {
    if (win.isWindow) win.show('SW_HIDE');
  }
  this.show = function() { _show(); }
  this.hide = function() { _hide(); }
  this.toggle = function() {
    if (win.isVisible()) _hide();
    else _show();
  }
})(sirius.thisDir);

